package com.example.android_actiondlg_test_1;

import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBar;
import android.support.v4.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.os.Build;

import android.widget.Button;
import android.view.View.OnClickListener;

import android.app.AlertDialog;
import android.widget.EditText;
import android.text.InputType;
import android.widget.CheckBox;
import android.widget.ToggleButton;
import android.content.DialogInterface;
import android.widget.Toast;

public class MainActivity extends ActionBarActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // ボタン押下イベントリスナーの登録
        Button button = (Button)findViewById(R.id.button_list_dlg);
        button.setOnClickListener(mButtonListDlgListener);

        button = (Button)findViewById(R.id.button_list_dlg2);
        button.setOnClickListener(mButtonListDlg2Listener);

        button = (Button)findViewById(R.id.button_check_dlg);
        button.setOnClickListener(mButtonCheckboxDlgListener);

        button = (Button)findViewById(R.id.button_quit);
        button.setOnClickListener(mButtonQuitListener);

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    // OKボタンのみのAlertDialogを表示する
    public void onClickButton_OkDlg(View view) {
    	// AlertDialogを構築する
        AlertDialog.Builder dlg = new AlertDialog.Builder(this);
        dlg.setIcon(android.R.drawable.ic_dialog_info);
        dlg.setTitle("OKボタンのみのAlertDialog");
        dlg.setMessage("ダイアログに表示する文字列");
        dlg.setPositiveButton("OK", null);
    	// AlertDialogを表示する
        dlg.show();
    }

    // Y/NボタンのAlertDialogを表示し、Yesが選択された場合はEditTextに文字列を設定する
    public void onClickButton_YnDlg(View view) {
    	// AlertDialogを構築する
        AlertDialog.Builder dlg = new AlertDialog.Builder(this);
        dlg.setTitle("Y/NボタンのAlertDialog");
        dlg.setMessage("ダイアログに表示する文字列");
        dlg.setPositiveButton("Yes", new DialogInterface.OnClickListener(){
            public void onClick(DialogInterface dialog, int which) {
                //Yesボタンが押された時の処理
                Toast.makeText(MainActivity.this, "Yesが押されました", Toast.LENGTH_LONG).show();
                EditText text1 = (EditText) MainActivity.this.findViewById(R.id.editText1);
                text1.setText("Yesが押されました");
            }});
        dlg.setNegativeButton("No", new DialogInterface.OnClickListener(){
            public void onClick(DialogInterface dialog, int which) {
                //Noボタンが押された時の処理
                Toast.makeText(MainActivity.this, "Noが押されました", Toast.LENGTH_LONG).show();
            }});
    	// AlertDialogを表示する
        dlg.show();
    }

    // テキスト入力のAlertDialogを表示し、入力された値をEditTextに設定する
    public void onClickButton_InputDlg(View view) {
        final EditText editView = new EditText(MainActivity.this);
        editView.setLines(1);	// 1行
        editView.setInputType(InputType.TYPE_CLASS_TEXT);	// 改行を許可しない
    	// AlertDialogを構築する
        AlertDialog.Builder dlg = new AlertDialog.Builder(this);
        dlg.setTitle("テキスト入力のAlertDialog");
        dlg.setMessage("ダイアログに表示する文字列");
        // テキストボックスに初期値を入力する
        dlg.setView(editView);
        EditText text1 = (EditText) MainActivity.this.findViewById(R.id.editText1);
        editView.setText(text1.getText().toString());
        dlg.setPositiveButton("Yes", new DialogInterface.OnClickListener(){
            public void onClick(DialogInterface dialog, int which) {
                //Yesボタンが押された時の処理
                Toast.makeText(MainActivity.this, "Yesが押されました", Toast.LENGTH_LONG).show();
                // 入力値をメインダイアログに書き戻す
                EditText text1 = (EditText) MainActivity.this.findViewById(R.id.editText1);
                text1.setText(editView.getText().toString());
            }});
        dlg.setNegativeButton("No", new DialogInterface.OnClickListener(){
            public void onClick(DialogInterface dialog, int which) {
                //Noボタンが押された時の処理
                Toast.makeText(MainActivity.this, "Noが押されました", Toast.LENGTH_LONG).show();
            }});
    	// AlertDialogを表示する
        dlg.show();
    }

    // リスト選択のAlertDialogを表示し、選択値をEditTextに設定する
    private OnClickListener mButtonListDlgListener = new OnClickListener() {
        public void onClick(View v) {
			// 選択肢リストを作成する
            final String[] items = new String[10];
            for(int i=0; i<10; i++) {
                items[i] = String.format("選択肢 %d", i);
            }
        	// AlertDialogを構築する
            AlertDialog.Builder dlg = new AlertDialog.Builder(MainActivity.this);
            dlg.setTitle("リストのAlertDialog");
            dlg.setItems(items, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int idx) {
                    Toast.makeText(MainActivity.this, String.format("%s が選択された", items[idx]), Toast.LENGTH_LONG).show();
                    // 入力値をメインダイアログに書き戻す
                    EditText text1 = (EditText) MainActivity.this.findViewById(R.id.editText1);
                    text1.setText(items[idx]);
                }
            });
            dlg.setNegativeButton("キャンセル", null);
        	// AlertDialogを表示する
            dlg.show();
        }
    };

    // リスト選択のAlertDialogを表示し、選択値をEditTextに設定する
    private OnClickListener mButtonListDlg2Listener = new OnClickListener() {
        private int selectedItem = 1;		// リストの選択値（onClickに対してグローバルで宣言する）
    	public void onClick(View v) {
			// 選択肢リストを作成する
    		final String[] items = new String[10];
            for(int i=0; i<10; i++) {
                items[i] = String.format("選択肢 %d", i);
            }
        	// AlertDialogを構築する
            AlertDialog.Builder dlg = new AlertDialog.Builder(MainActivity.this);
            dlg.setTitle("リストのAlertDialog");
            dlg.setSingleChoiceItems(items, selectedItem, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int idx) {
                    selectedItem = idx;
                }
            });
            dlg.setPositiveButton("OK", new DialogInterface.OnClickListener(){
                public void onClick(DialogInterface dialog, int idx) {
                    //Yesボタンが押された時の処理
                    Toast.makeText(MainActivity.this, String.format("%s が選択された", items[selectedItem]), Toast.LENGTH_LONG).show();
                    // 入力値をメインダイアログに書き戻す
                    EditText text1 = (EditText) MainActivity.this.findViewById(R.id.editText1);
                    text1.setText(items[selectedItem]);
                }});
            dlg.setNegativeButton("キャンセル", null);
        	// AlertDialogを表示する
            dlg.show();
        }
    };

    // チェックボックスのリストを表示し、選択値を画面上のチェックボックスとプッシュボタンに反映する
    private OnClickListener mButtonCheckboxDlgListener = new OnClickListener() {
        private boolean[] checkedItems = {false, false};		// リストの選択値（onClickに対してグローバルで宣言する）
        public void onClick(View v) {
            final String[] items = {"チェックボックス", "トグルボタン"};
        	// 現在のチェック状態を読み出す
            CheckBox checkBox = (CheckBox) MainActivity.this.findViewById(R.id.checkBox1);
            if(checkBox.isChecked()){ checkedItems[0] = true; }
            ToggleButton toggleButton = (ToggleButton) MainActivity.this.findViewById(R.id.toggleButton1);
            if(toggleButton.isChecked()){ checkedItems[1] = true; }
        	// AlertDialogを構築する
            AlertDialog.Builder dlg = new AlertDialog.Builder(MainActivity.this);
            dlg.setTitle("チェックボックスのAlertDialog");
            dlg.setMultiChoiceItems(items, checkedItems, new DialogInterface.OnMultiChoiceClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int idx, boolean isChecked) {
                    checkedItems[idx] = isChecked;
                    Toast.makeText(MainActivity.this, String.format("idx=%d, sel=%b", idx, isChecked), Toast.LENGTH_LONG).show();
                }
            });
            dlg.setPositiveButton("OK", new DialogInterface.OnClickListener(){
                public void onClick(DialogInterface dialog, int idx) {
                    //Yesボタンが押された時の処理
                    // 入力値をメインダイアログに書き戻す
                    CheckBox checkBox = (CheckBox) MainActivity.this.findViewById(R.id.checkBox1);
                    checkBox.setChecked(checkedItems[0]);
                    ToggleButton toggleButton = (ToggleButton) MainActivity.this.findViewById(R.id.toggleButton1);
                    toggleButton.setChecked(checkedItems[1]);
                }});
            dlg.setNegativeButton("キャンセル", null);
        	// AlertDialogを表示する
            dlg.show();
        }
    };

    // 終了ボタン
    private OnClickListener mButtonQuitListener = new OnClickListener() {
        public void onClick(View v) {
        	finish();
        }
    };

}
